(* ------------------------------------------------------ *)
(*                     CHEAPCRT.PAS                       *)
(*            "Clone" der Original-Crt-Unit               *)
(*       (c) 1991 Hanno-Ekkehard Mller & TOOLBOX         *)
(* ------------------------------------------------------ *)
UNIT CheapCrt;

INTERFACE

CONST
  BW40 = 0;
  Co40 = 1;
  BW80 = 2;
  Co80 = 3;
  Mono = 7;
  C40  = Co40;
  C80  = Co80;

  PROCEDURE TextMode(Mode : BYTE);
  PROCEDURE GotoXY(X, Y : BYTE);
  FUNCTION  WhereX : BYTE;
  FUNCTION  WhereY : BYTE;
  PROCEDURE ClrScr;
  FUNCTION  KeyPressed : BOOLEAN;
  FUNCTION  ReadKey : CHAR;
  PROCEDURE Sound(Hz : WORD);
  PROCEDURE NoSound;

IMPLEMENTATION

  PROCEDURE TextMode(Mode : BYTE);  EXTERNAL;
  PROCEDURE GotoXY(X, Y : BYTE);    EXTERNAL;
  FUNCTION  WhereX : BYTE;          EXTERNAL;
  FUNCTION  WhereY : BYTE;          EXTERNAL;
  PROCEDURE ClrScr;                 EXTERNAL;
  FUNCTION  KeyPressed : BOOLEAN;   EXTERNAL;
  FUNCTION  ReadKey : CHAR;         EXTERNAL;
  PROCEDURE Sound(Hz : WORD);       EXTERNAL;
  PROCEDURE NoSound;                EXTERNAL;

{$L CHEAPCRT}

END.
(* ------------------------------------------------------ *)
(*               Ende von CHEAPCRT.PAS                    *)